<?php
/**
* @version		2.5.0
* @package		AceSEF
* @subpackage	AceSEF
* @copyright	2009-2012 JoomAce LLC, www.joomace.net
* @license		GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

// No Permission
defined('_JEXEC') or die('Restricted Access');

AcesefUtility::import('library.sitemap');

// Model Class
class AcesefModelConfig extends AcesefModel {

	// Main constructer
	function __construct() {
        parent::__construct('config');
    }
    
	// Save configuration
	function save() {
		$config = new stdClass();
		
		// Main
		$config->mode							= JFactory::getApplication()->input->get('mode', 							1, 			'post', 'int');
		$config->generate_sef					= JFactory::getApplication()->input->get('generate_sef', 					1, 			'post', 'int');
		$config->version_checker				= JFactory::getApplication()->input->get('version_checker', 				1, 			'post', 'int');
		$config->jquery_mode					= JFactory::getApplication()->input->get('jquery_mode', 					1, 			'post', 'int');
		$config->download_id					= JFactory::getApplication()->input->get('download_id', 					'', 		'post',	'string');
		$config->cache_instant					= JFactory::getApplication()->input->get('cache_instant', 				1, 			'post', 'int');
		$config->cache_versions					= JFactory::getApplication()->input->get('cache_versions', 				1, 			'post', 'int');
		$config->cache_extensions				= JFactory::getApplication()->input->get('cache_extensions', 				1, 			'post', 'int');
		$config->cache_urls						= JFactory::getApplication()->input->get('cache_urls', 					1, 			'post', 'int');
		$config->cache_urls_size				= JFactory::getApplication()->input->get('cache_urls_size', 				'10000', 	'post',	'string');
		$config->cache_metadata					= JFactory::getApplication()->input->get('cache_metadata', 				1, 			'post', 'int');
		$config->cache_sitemap					= JFactory::getApplication()->input->get('cache_sitemap', 				1, 			'post', 'int');
		$config->cache_urls_moved				= JFactory::getApplication()->input->get('cache_urls_moved', 				1, 			'post', 'int');
		$config->cache_tags						= JFactory::getApplication()->input->get('cache_tags', 					1, 			'post', 'int');
		$config->cache_ilinks					= JFactory::getApplication()->input->get('cache_ilinks', 					1, 			'post', 'int');
		$config->seo_nofollow					= JFactory::getApplication()->input->get('seo_nofollow', 					0, 			'post', 'int');
		$config->page404						= JFactory::getApplication()->input->get('page404', 						'custom', 	'post', 'string');
		
		// URL
		$config->url_lowercase					= JFactory::getApplication()->input->get('url_lowercase', 				0, 			'post', 'int');
		$config->global_smart_itemid			= JFactory::getApplication()->input->get('global_smart_itemid', 			1, 			'post', 'int');
		$config->ignore_multi_itemid			= JFactory::getApplication()->input->get('ignore_multi_itemid', 			0, 			'post', 'int');
		$config->numeral_duplicated				= JFactory::getApplication()->input->get('numeral_duplicated', 			0, 			'post', 'int');
		$config->record_duplicated				= JFactory::getApplication()->input->get('record_duplicated', 			1, 			'post', 'int');
		$config->url_suffix						= JFactory::getApplication()->input->get('url_suffix', 					'', 		'post', 'string');
		$config->replacement_character			= JFactory::getApplication()->input->get('replacement_character',			'', 		'post', 'string');
		$config->parent_menus					= JFactory::getApplication()->input->get('parent_menus', 					0, 			'post', 'int');
		$config->menu_url_part					= JFactory::getApplication()->input->get('menu_url_part',					'title', 	'post', 'string');
		$config->title_alias					= JFactory::getApplication()->input->get('title_alias', 					'title', 	'post', 'string');
		$config->append_itemid					= JFactory::getApplication()->input->get('append_itemid', 				0, 			'post', 'int');
		$config->remove_trailing_slash			= JFactory::getApplication()->input->get('remove_trailing_slash', 		1, 			'post', 'int');
		$config->tolerant_to_trailing_slash		= JFactory::getApplication()->input->get('tolerant_to_trailing_slash', 	1, 			'post', 'int');
		$config->url_strip_chars				= JFactory::getApplication()->input->get('url_strip_chars',				'', 		'post', 'string');
		$config->source_tracker					= JFactory::getApplication()->input->get('source_tracker', 				0, 			'post', 'int');
		$config->insert_active_itemid			= JFactory::getApplication()->input->get('insert_active_itemid', 			0, 			'post', 'int');
		$config->remove_sid						= JFactory::getApplication()->input->get('remove_sid', 					1, 			'post', 'int');
		$config->set_query_string				= JFactory::getApplication()->input->get('set_query_string', 				0, 			'post', 'int');
		$config->base_href						= JFactory::getApplication()->input->get('base_href', 					3, 			'post', 'int');
		$config->append_non_sef					= JFactory::getApplication()->input->get('append_non_sef', 				1, 			'post', 'int');
		$config->prevent_dup_error				= JFactory::getApplication()->input->get('prevent_dup_error', 			1, 			'post', 'int');
		$config->show_db_errors					= JFactory::getApplication()->input->get('show_db_errors', 				0, 			'post', 'int');
		$config->check_url_by_id				= JFactory::getApplication()->input->get('check_url_by_id', 				1, 			'post', 'int');
		$config->non_sef_vars					= JFactory::getApplication()->input->get('non_sef_vars', 					'', 		'post', 'string');
		$config->disable_sef_vars				= JFactory::getApplication()->input->get('disable_sef_vars', 				'', 		'post', 'string');
		$config->skip_menu_vars					= JFactory::getApplication()->input->get('skip_menu_vars', 				'', 		'post', 'string');
		$config->db_404_errors					= JFactory::getApplication()->input->get('db_404_errors', 				1, 			'post', 'int');
		$config->log_404_errors					= JFactory::getApplication()->input->get('log_404_errors', 				0, 			'post', 'int');
		$config->sent_headers_error				= JFactory::getApplication()->input->get('sent_headers_error', 			0, 			'post', 'int');
		$config->multilang				        = JFactory::getApplication()->input->get('multilang', 			'0', 		'post', 'string');
		$config->joomfish_main_lang				= JFactory::getApplication()->input->get('joomfish_main_lang', 			'0', 		'post', 'string');
		$config->joomfish_main_lang_del			= JFactory::getApplication()->input->get('joomfish_main_lang_del', 		0, 			'post', 'int');
		$config->joomfish_lang_code				= JFactory::getApplication()->input->get('joomfish_lang_code', 			1, 			'post', 'int');
		$config->joomfish_trans_url				= JFactory::getApplication()->input->get('joomfish_trans_url', 			1, 			'post', 'int');
		$config->joomfish_cookie				= JFactory::getApplication()->input->get('joomfish_cookie', 				1, 			'post', 'int');
		$config->joomfish_browser				= JFactory::getApplication()->input->get('joomfish_browser', 				1, 			'post', 'int');
		$config->utf8_url						= JFactory::getApplication()->input->get('utf8_url', 						0, 			'post', 'int');
		$config->char_replacements				= JFactory::getApplication()->input->get('char_replacements',				'', 		'post', 'string');
		$config->redirect_to_www				= JFactory::getApplication()->input->get('redirect_to_www', 				0, 			'post', 'int');
		$config->redirect_to_sef				= JFactory::getApplication()->input->get('redirect_to_sef', 				1, 			'post', 'int');
		$config->redirect_to_sef_gen			= JFactory::getApplication()->input->get('redirect_to_sef_gen', 			0, 			'post', 'int');
		$config->jsef_to_acesef					= JFactory::getApplication()->input->get('jsef_to_acesef', 				1, 			'post', 'int');
		$config->force_ssl						= JFactory::getApplication()->input->get('force_ssl', 					array(), 	'post', 'array');
		$config->url_append_limit				= JFactory::getApplication()->input->get('url_append_limit', 				0, 			'post', 'int');
		$config->purge_ext_urls					= JFactory::getApplication()->input->get('purge_ext_urls', 				1, 			'post', 'int');
		$config->delete_other_sef				= JFactory::getApplication()->input->get('delete_other_sef', 				1, 			'post', 'int');
		
		// Meta Tags
		$config->meta_core						= JFactory::getApplication()->input->get('meta_core', 					1, 			'post', 'int');
		$config->meta_title						= JFactory::getApplication()->input->get('meta_title', 					1, 			'post', 'int');
		$config->meta_title_tag					= JFactory::getApplication()->input->get('meta_title_tag', 				1, 			'post', 'int');
		$config->meta_desc						= JFactory::getApplication()->input->get('meta_desc', 					1, 			'post', 'int');
		$config->meta_key						= JFactory::getApplication()->input->get('meta_key', 						1, 			'post', 'int');
		$config->meta_generator					= JFactory::getApplication()->input->get('meta_generator', 				'', 		'post', 'string');
		$config->meta_generator_rem				= JFactory::getApplication()->input->get('meta_generator_rem', 			0, 			'post', 'int');
		$config->meta_abstract					= JFactory::getApplication()->input->get('meta_abstract', 				'', 		'post', 'string');
		$config->meta_revisit					= JFactory::getApplication()->input->get('meta_revisit', 					'', 		'post', 'string');
		$config->meta_direction					= JFactory::getApplication()->input->get('meta_direction', 				'', 		'post', 'string');
		$config->meta_googlekey					= JFactory::getApplication()->input->get('meta_googlekey', 				'', 		'post', 'string');
		$config->meta_livekey					= JFactory::getApplication()->input->get('meta_livekey', 					'', 		'post', 'string');
		$config->meta_yahookey					= JFactory::getApplication()->input->get('meta_yahookey', 				'', 		'post', 'string');
		$config->meta_alexa						= JFactory::getApplication()->input->get('meta_alexa', 					'', 		'post', 'string');
		$config->meta_name_1					= JFactory::getApplication()->input->get('meta_name_1', 					'', 		'post', 'string');
		$config->meta_name_2					= JFactory::getApplication()->input->get('meta_name_2', 					'', 		'post', 'string');
		$config->meta_name_3					= JFactory::getApplication()->input->get('meta_name_3', 					'', 		'post', 'string');
		$config->meta_con_1						= JFactory::getApplication()->input->get('meta_con_1', 					'', 		'post', 'string');
		$config->meta_con_2						= JFactory::getApplication()->input->get('meta_con_2', 					'', 		'post', 'string');
		$config->meta_con_3						= JFactory::getApplication()->input->get('meta_con_3', 					'', 		'post', 'string');
		$config->meta_t_seperator				= JFactory::getApplication()->input->get('meta_t_seperator', 				'-', 		'post', 'string');
		$config->meta_t_sitename					= JFactory::getApplication()->input->get('meta_t_sitename', 			'', 		'post', 'string');
		$config->meta_t_usesitename				= JFactory::getApplication()->input->get('meta_t_usesitename', 			2, 			'post', 'int');
		$config->meta_t_prefix					= JFactory::getApplication()->input->get('meta_t_prefix', 				'', 		'post', 'string');
		$config->meta_t_suffix					= JFactory::getApplication()->input->get('meta_t_suffix', 				'', 		'post', 'string');
		$config->meta_key_blacklist				= JFactory::getApplication()->input->get('meta_key_blacklist', 			'', 		'post', 'string');
		$config->meta_key_whitelist				= JFactory::getApplication()->input->get('meta_key_whitelist', 			'', 		'post', 'string');
		
		// Sitemap
		$config->sm_file						= JFactory::getApplication()->input->get('sm_file', 						'sitemap', 	'post', 'string');
		$config->sm_xml_date					= JFactory::getApplication()->input->get('sm_xml_date', 					1, 			'post', 'int');
		$config->sm_xml_freq					= JFactory::getApplication()->input->get('sm_xml_freq', 					1, 			'post', 'int');
		$config->sm_xml_prior					= JFactory::getApplication()->input->get('sm_xml_prior', 					1, 			'post', 'int');
		$config->sm_dot_tree					= JFactory::getApplication()->input->get('sm_dot_tree', 					0, 			'post', 'int');
		$config->sm_ping_type					= JFactory::getApplication()->input->get('sm_ping_type', 					'link', 	'post', 'string');
		$config->sm_ping						= JFactory::getApplication()->input->get('sm_ping', 						1, 			'post', 'int');
		$config->sm_yahoo_appid					= JFactory::getApplication()->input->get('sm_yahoo_appid', 				'', 		'post', 'string');
		$config->sm_ping_services				= JFactory::getApplication()->input->get('sm_ping_services', 				'', 		'post', 'string');
		$config->sm_freq						= JFactory::getApplication()->input->get('sm_freq', 						'weekly', 	'post', 'string');
		$config->sm_priority					= JFactory::getApplication()->input->get('sm_priority', 					'0.5', 		'post', 'string');
		$config->sm_auto_mode					= JFactory::getApplication()->input->get('sm_auto_mode', 					1, 			'post', 'int');
		$config->sm_auto_components				= JFactory::getApplication()->input->get('sm_auto_components',			array(), 	'post', 'array');
		$config->sm_auto_enable_cats			= JFactory::getApplication()->input->get('sm_auto_enable_cats', 			0, 			'post', 'int');
		$config->sm_auto_filter_s				= JFactory::getApplication()->input->get('sm_auto_filter_s', 				'', 		'post', 'string');
		$config->sm_auto_filter_r				= JFactory::getApplication()->input->get('sm_auto_filter_r', 				'', 		'post', 'string');
		$config->sm_auto_cron_mode				= JFactory::getApplication()->input->get('sm_auto_cron_mode', 			0, 			'post', 'int');
		$config->sm_auto_cron_freq				= JFactory::getApplication()->input->get('sm_auto_cron_freq', 			'24', 		'post', 'int');
		$config->sm_auto_cron_last				= JFactory::getApplication()->input->get('sm_auto_cron_last', 			'', 		'post', 'string');
		$config->sm_auto_xml					= JFactory::getApplication()->input->get('sm_auto_xml', 					1, 			'post', 'int');
		$config->sm_auto_ping_c					= JFactory::getApplication()->input->get('sm_auto_ping_c', 				0, 			'post', 'int');
		$config->sm_auto_ping_s					= JFactory::getApplication()->input->get('sm_auto_ping_s', 				0, 			'post', 'int');
		
		// Tags
		$config->tags_mode						= JFactory::getApplication()->input->get('tags_mode', 					1, 			'post', 'int');
		$config->tags_area						= JFactory::getApplication()->input->get('tags_area', 					1, 			'post', 'int');
		$config->tags_components				= JFactory::getApplication()->input->get('tags_components',				array(), 	'post', 'array');
		$config->tags_enable_cats				= JFactory::getApplication()->input->get('tags_enable_cats', 				0, 			'post', 'int');
		$config->tags_in_cats					= JFactory::getApplication()->input->get('tags_in_cats', 					0, 			'post', 'int');
		$config->tags_in_page					= JFactory::getApplication()->input->get('tags_in_page', 					15, 		'post', 'int');
		$config->tags_order						= JFactory::getApplication()->input->get('tags_order', 					'ordering', 'post', 'string');
		$config->tags_position					= JFactory::getApplication()->input->get('tags_position', 				2, 			'post', 'int');
		$config->tags_limit						= JFactory::getApplication()->input->get('tags_limit', 					20, 		'post', 'int');
		$config->tags_show_tag_desc				= JFactory::getApplication()->input->get('tags_show_tag_desc', 			0, 			'post', 'int');
		$config->tags_show_prefix				= JFactory::getApplication()->input->get('tags_show_prefix', 				1, 			'post', 'int');
		$config->tags_show_item_desc			= JFactory::getApplication()->input->get('tags_show_item_desc', 			1, 			'post', 'int');
		$config->tags_exp_item_desc				= JFactory::getApplication()->input->get('tags_exp_item_desc', 			0, 			'post', 'int');
		$config->tags_published					= JFactory::getApplication()->input->get('tags_published', 				1, 			'post', 'int');
		$config->tags_auto_mode					= JFactory::getApplication()->input->get('tags_auto_mode', 				0, 			'post', 'int');
		$config->tags_auto_components			= JFactory::getApplication()->input->get('tags_auto_components',			array(), 	'post', 'array');
		$config->tags_auto_length				= JFactory::getApplication()->input->get('tags_auto_length', 				4, 			'post', 'int');
		$config->tags_auto_filter_s				= JFactory::getApplication()->input->get('tags_auto_filter_s', 			'', 		'post', 'string');
		$config->tags_auto_filter_r				= JFactory::getApplication()->input->get('tags_auto_filter_r', 			'', 		'post', 'string');
		$config->tags_auto_blacklist			= JFactory::getApplication()->input->get('tags_auto_blacklist', 			'', 		'post', 'string');
		
		// Internal Links
		$config->ilinks_mode					= JFactory::getApplication()->input->get('ilinks_mode', 					0, 			'post', 'int');
		$config->ilinks_area					= JFactory::getApplication()->input->get('ilinks_area', 					1, 			'post', 'int');
		$config->ilinks_components				= JFactory::getApplication()->input->get('ilinks_components',				array(), 	'post', 'array');
		$config->ilinks_enable_cats				= JFactory::getApplication()->input->get('ilinks_enable_cats', 			1, 			'post', 'int');
		$config->ilinks_in_cats					= JFactory::getApplication()->input->get('ilinks_in_cats', 				0, 			'post', 'int');
		$config->ilinks_case					= JFactory::getApplication()->input->get('ilinks_case', 					1, 			'post', 'int');
		$config->ilinks_published				= JFactory::getApplication()->input->get('ilinks_published', 				1, 			'post', 'int');
		$config->ilinks_nofollow				= JFactory::getApplication()->input->get('ilinks_nofollow', 				0, 			'post', 'int');
		$config->ilinks_blank					= JFactory::getApplication()->input->get('ilinks_blank', 					0, 			'post', 'int');
		$config->ilinks_limit					= JFactory::getApplication()->input->get('ilinks_limit', 					10, 		'post', 'int');
		
		// Social Bookmarks
		$config->bookmarks_mode					= JFactory::getApplication()->input->get('bookmarks_mode', 				0, 			'post', 'int');
		$config->bookmarks_area					= JFactory::getApplication()->input->get('bookmarks_area', 				1, 			'post', 'int');
		$config->bookmarks_components			= JFactory::getApplication()->input->get('bookmarks_components',			array(), 	'post', 'array');
		$config->bookmarks_enable_cats			= JFactory::getApplication()->input->get('bookmarks_enable_cats', 		1, 			'post', 'int');
		$config->bookmarks_in_cats				= JFactory::getApplication()->input->get('bookmarks_in_cats', 			0, 			'post', 'int');
		$config->bookmarks_twitter				= JFactory::getApplication()->input->get('bookmarks_twitter', 			'', 		'post', 'string');
		$config->bookmarks_addthis				= JFactory::getApplication()->input->get('bookmarks_addthis', 			'', 		'post', 'string');
		$config->bookmarks_taf					= JFactory::getApplication()->input->get('bookmarks_taf', 				'', 		'post', 'string');
		$config->bookmarks_icons_pos			= JFactory::getApplication()->input->get('bookmarks_icons_pos', 			2, 			'post', 'int');
		$config->bookmarks_icons_txt			= JFactory::getApplication()->input->get('bookmarks_icons_txt', 			'', 		'post', 'string');
		$config->bookmarks_icons_line			= JFactory::getApplication()->input->get('bookmarks_icons_line', 			35, 		'post', 'int');
		$config->bookmarks_published			= JFactory::getApplication()->input->get('bookmarks_published', 			1, 			'post', 'int');
		$config->bookmarks_type					= JFactory::getApplication()->input->get('bookmarks_type', 				'icon', 	'post', 'string');
		
		// User Interface
		$config->ui_cpanel						= JFactory::getApplication()->input->get('ui_cpanel', 					2, 			'post', 'int');
		$config->ui_sef_language				= JFactory::getApplication()->input->get('ui_sef_language', 				0, 			'post', 'int');
		$config->ui_sef_published				= JFactory::getApplication()->input->get('ui_sef_published', 				1, 			'post', 'int');
		$config->ui_sef_used					= JFactory::getApplication()->input->get('ui_sef_used', 					1, 			'post', 'int');
		$config->ui_sef_locked					= JFactory::getApplication()->input->get('ui_sef_locked', 				1, 			'post', 'int');
		$config->ui_sef_blocked					= JFactory::getApplication()->input->get('ui_sef_blocked', 				0, 			'post', 'int');
		$config->ui_sef_cached					= JFactory::getApplication()->input->get('ui_sef_cached', 				1, 			'post', 'int');
		$config->ui_sef_date					= JFactory::getApplication()->input->get('ui_sef_date', 					0, 			'post', 'int');
		$config->ui_sef_hits					= JFactory::getApplication()->input->get('ui_sef_hits', 					1, 			'post', 'int');
		$config->ui_sef_id						= JFactory::getApplication()->input->get('ui_sef_id', 					0, 			'post', 'int');
		$config->ui_moved_published				= JFactory::getApplication()->input->get('ui_moved_published', 			1, 			'post', 'int');
		$config->ui_moved_hits					= JFactory::getApplication()->input->get('ui_moved_hits', 				1, 			'post', 'int');
		$config->ui_moved_clicked				= JFactory::getApplication()->input->get('ui_moved_clicked', 				1, 			'post', 'int');
		$config->ui_moved_cached				= JFactory::getApplication()->input->get('ui_moved_cached', 				1, 			'post', 'int');
		$config->ui_moved_id					= JFactory::getApplication()->input->get('ui_moved_id', 					1, 			'post', 'int');
		$config->ui_metadata_keys				= JFactory::getApplication()->input->get('ui_metadata_keys', 				1, 			'post', 'int');
		$config->ui_metadata_published			= JFactory::getApplication()->input->get('ui_metadata_published', 		1, 			'post', 'int');
		$config->ui_metadata_cached				= JFactory::getApplication()->input->get('ui_metadata_cached', 			1, 			'post', 'int');
		$config->ui_metadata_id					= JFactory::getApplication()->input->get('ui_metadata_id', 				0, 			'post', 'int');
		$config->ui_sitemap_title				= JFactory::getApplication()->input->get('ui_sitemap_title', 				1, 			'post', 'int');
		$config->ui_sitemap_published			= JFactory::getApplication()->input->get('ui_sitemap_published', 			1, 			'post', 'int');
		$config->ui_sitemap_id					= JFactory::getApplication()->input->get('ui_sitemap_id', 				1, 			'post', 'int');
		$config->ui_sitemap_parent				= JFactory::getApplication()->input->get('ui_sitemap_parent', 			1, 			'post', 'int');
		$config->ui_sitemap_order				= JFactory::getApplication()->input->get('ui_sitemap_order', 				1, 			'post', 'int');
		$config->ui_sitemap_date				= JFactory::getApplication()->input->get('ui_sitemap_date', 				1, 			'post', 'int');
		$config->ui_sitemap_frequency			= JFactory::getApplication()->input->get('ui_sitemap_frequency', 			1, 			'post', 'int');
		$config->ui_sitemap_priority			= JFactory::getApplication()->input->get('ui_sitemap_priority', 			1, 			'post', 'int');
		$config->ui_sitemap_cached				= JFactory::getApplication()->input->get('ui_sitemap_cached', 			1, 			'post', 'int');
		$config->ui_tags_published				= JFactory::getApplication()->input->get('ui_tags_published', 			1, 			'post', 'int');
		$config->ui_tags_ordering				= JFactory::getApplication()->input->get('ui_tags_ordering', 				1, 			'post', 'int');
		$config->ui_tags_cached					= JFactory::getApplication()->input->get('ui_tags_cached', 				1, 			'post', 'int');
		$config->ui_tags_hits					= JFactory::getApplication()->input->get('ui_tags_hits', 					1, 			'post', 'int');
		$config->ui_tags_id						= JFactory::getApplication()->input->get('ui_tags_id', 					0, 			'post', 'int');
		$config->ui_ilinks_published			= JFactory::getApplication()->input->get('ui_ilinks_published', 			1, 			'post', 'int');
		$config->ui_ilinks_nofollow				= JFactory::getApplication()->input->get('ui_ilinks_nofollow', 			1, 			'post', 'int');
		$config->ui_ilinks_blank				= JFactory::getApplication()->input->get('ui_ilinks_blank', 				1, 			'post', 'int');
		$config->ui_ilinks_limit				= JFactory::getApplication()->input->get('ui_ilinks_limit', 				1, 			'post', 'int');
		$config->ui_ilinks_cached				= JFactory::getApplication()->input->get('ui_ilinks_cached', 				1, 			'post', 'int');
		$config->ui_ilinks_id					= JFactory::getApplication()->input->get('ui_ilinks_id', 					1, 			'post', 'int');
		$config->ui_bookmarks_published			= JFactory::getApplication()->input->get('ui_bookmarks_published', 		1, 			'post', 'int');
		$config->ui_bookmarks_id				= JFactory::getApplication()->input->get('ui_bookmarks_id', 				1, 			'post', 'int');
		
		// Save 404 Page
        $introtext = (get_magic_quotes_gpc() ? $_POST['introtext'] : addslashes($_POST['introtext']));
        if ($id = AceDatabase::loadResult('SELECT id FROM #__content WHERE `title` = "404"')){
            $sql = 'UPDATE #__content SET introtext="'.$introtext.'", modified ="'.date("Y-m-d H:i:s").'" WHERE `id` = "'.$id.'";';
        }
		else {
			$attribs = '{\"show_title\":\"0\",\"link_titles\":\"0\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_vote\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}';
            $sql = 'INSERT INTO #__content (title, alias, introtext, `fulltext`, state, catid, created, created_by, created_by_alias, modified, modified_by, checked_out, checked_out_time, publish_up, publish_down, images, urls, attribs, version, ordering, metakey, metadesc, access, hits, language) '.
			'VALUES("404", "404", "'.$introtext.'", "", "1", "9", "2011-06-11 12:44:38", "42", "", "'.date("Y-m-d H:i:s").'", "42", "0", "2011-06-11 12:45:09", "2011-05-17 00:00:00", "0000-00-00 00:00:00", "", "", "'.$attribs.'", "1", "0", "", "", "1", "0", "*");';
        }
		AceDatabase::query($sql);
		
		AcesefUtility::storeConfig($config);
	}
	
	function getLists() {
        JLoader::register('JHtmlSelect', JPATH_ACESEF_ADMIN.'/library/joomla/select.php');

		$lists = array();
		
		// Affected Area
		$areas = array();
  		$areas[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_AREA_1'));
		$areas[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_AREA_2'));
		$areas[] = JHTML::_('select.option', '3', JText::_('ACESEF_CONFIG_AREA_3'));
		
		/*
		//
		// Main
		//
		*/
		
		$lists['mode'] 				= AcesefUtility::getRadioList('mode', $this->AcesefConfig->mode);
		$lists['generate_sef'] 		= AcesefUtility::getRadioList('generate_sef', $this->AcesefConfig->generate_sef);
		$lists['version_checker'] 	= AcesefUtility::getRadioList('version_checker', $this->AcesefConfig->version_checker);
		$lists['jquery_mode'] 		= AcesefUtility::getRadioList('jquery_mode', $this->AcesefConfig->jquery_mode);
		$lists['seo_nofollow'] 		= AcesefUtility::getRadioList('seo_nofollow', $this->AcesefConfig->seo_nofollow);
		$lists['cache_instant'] 	= AcesefUtility::getRadioList('cache_instant', $this->AcesefConfig->cache_instant);
		$lists['cache_versions'] 	= AcesefUtility::getRadioList('cache_versions', $this->AcesefConfig->cache_versions);
		$lists['cache_extensions'] 	= AcesefUtility::getRadioList('cache_extensions', $this->AcesefConfig->cache_extensions);
		$lists['cache_urls'] 		= AcesefUtility::getRadioList('cache_urls', $this->AcesefConfig->cache_urls);
		$lists['cache_urls_moved'] 	= AcesefUtility::getRadioList('cache_urls_moved', $this->AcesefConfig->cache_urls_moved);
		$lists['cache_metadata'] 	= AcesefUtility::getRadioList('cache_metadata', $this->AcesefConfig->cache_metadata);
		$lists['cache_sitemap'] 	= AcesefUtility::getRadioList('cache_sitemap', $this->AcesefConfig->cache_sitemap);
		$lists['cache_tags'] 		= AcesefUtility::getRadioList('cache_tags', $this->AcesefConfig->cache_tags);
		$lists['cache_ilinks'] 		= AcesefUtility::getRadioList('cache_ilinks', $this->AcesefConfig->cache_ilinks);
		
		// 404 Page
		$page404 = array();
  		$page404[] = JHTML::_('select.option', 'home', JText::_('ACESEF_CONFIG_MAIN_404_HOME'));
		$page404[] = JHTML::_('select.option', 'custom', JText::_('ACESEF_CONFIG_MAIN_404_CUSTOM'));
		$page404[] = JHTML::_('select.option', 'joomla', JText::_('ACESEF_CONFIG_MAIN_404_JOOMLA'));
		$lists['page404'] = JHTML::_('select.genericlist', $page404, 'page404', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->page404);
		
		// Custom 404 Page
        $row = AceDatabase::loadObject("SELECT `id`, `introtext` FROM `#__content` WHERE `title` = '404'");
		$lists['custom404'] = isset($row->introtext) ? $row->introtext : JText::_('<h1>404: Not Found</h1><h4>Sorry, but the content you requested could not be found</h4>');

		/*
		//
		// URL
		//
		*/
		$lists['url_lowercase'] 			= AcesefUtility::getRadioList('url_lowercase', $this->AcesefConfig->url_lowercase);
		$lists['global_smart_itemid'] 		= AcesefUtility::getRadioList('global_smart_itemid', $this->AcesefConfig->global_smart_itemid);
		$lists['ignore_multi_itemid'] 		= AcesefUtility::getRadioList('ignore_multi_itemid', $this->AcesefConfig->ignore_multi_itemid);
		$lists['numeral_duplicated'] 		= AcesefUtility::getRadioList('numeral_duplicated', $this->AcesefConfig->numeral_duplicated);
		$lists['record_duplicated'] 		= AcesefUtility::getRadioList('record_duplicated', $this->AcesefConfig->record_duplicated);
		$lists['parent_menus'] 				= AcesefUtility::getRadioList('parent_menus', $this->AcesefConfig->parent_menus);
		$lists['append_itemid'] 			= AcesefUtility::getRadioList('append_itemid', $this->AcesefConfig->append_itemid);
		$lists['remove_trailing_slash'] 	= AcesefUtility::getRadioList('remove_trailing_slash', $this->AcesefConfig->remove_trailing_slash);
		$lists['tolerant_to_trailing_slash']= AcesefUtility::getRadioList('tolerant_to_trailing_slash', $this->AcesefConfig->tolerant_to_trailing_slash);
		$lists['source_tracker'] 			= AcesefUtility::getRadioList('source_tracker', $this->AcesefConfig->source_tracker);
		$lists['insert_active_itemid'] 		= AcesefUtility::getRadioList('insert_active_itemid', $this->AcesefConfig->insert_active_itemid);
		$lists['remove_sid'] 				= AcesefUtility::getRadioList('remove_sid', $this->AcesefConfig->remove_sid);
		$lists['set_query_string'] 			= AcesefUtility::getRadioList('set_query_string', $this->AcesefConfig->set_query_string);
		$lists['append_non_sef'] 			= AcesefUtility::getRadioList('append_non_sef', $this->AcesefConfig->append_non_sef);
		$lists['prevent_dup_error'] 		= AcesefUtility::getRadioList('prevent_dup_error', $this->AcesefConfig->prevent_dup_error);
		$lists['show_db_errors'] 			= AcesefUtility::getRadioList('show_db_errors', $this->AcesefConfig->show_db_errors);
		$lists['check_url_by_id'] 			= AcesefUtility::getRadioList('check_url_by_id', $this->AcesefConfig->check_url_by_id);
		$lists['db_404_errors'] 			= AcesefUtility::getRadioList('db_404_errors', $this->AcesefConfig->db_404_errors);
		$lists['log_404_errors'] 			= AcesefUtility::getRadioList('log_404_errors', $this->AcesefConfig->log_404_errors);
		$lists['sent_headers_error'] 		= AcesefUtility::getRadioList('sent_headers_error', $this->AcesefConfig->sent_headers_error);
		$lists['utf8_url'] 					= AcesefUtility::getRadioList('utf8_url', $this->AcesefConfig->utf8_url);
		$lists['redirect_to_sef'] 			= AcesefUtility::getRadioList('redirect_to_sef', $this->AcesefConfig->redirect_to_sef);
		$lists['redirect_to_sef_gen'] 		= AcesefUtility::getRadioList('redirect_to_sef_gen', $this->AcesefConfig->redirect_to_sef_gen);
		$lists['jsef_to_acesef'] 			= AcesefUtility::getRadioList('jsef_to_acesef', $this->AcesefConfig->jsef_to_acesef);
		$lists['force_ssl'] 				= AcesefUtility::getRadioList('force_ssl', $this->AcesefConfig->force_ssl);
		$lists['url_append_limit'] 			= AcesefUtility::getRadioList('url_append_limit', $this->AcesefConfig->url_append_limit);
		$lists['purge_ext_urls'] 			= AcesefUtility::getRadioList('purge_ext_urls', $this->AcesefConfig->purge_ext_urls);
		$lists['delete_other_sef'] 			= AcesefUtility::getRadioList('delete_other_sef', $this->AcesefConfig->delete_other_sef);
		
		// Title-Alias
		$url_part = array();
		$url_part[] = JHTML::_('select.option', 'title', JText::_('ACESEF_COMMON_TITLE_FIELD'));
  		$url_part[] = JHTML::_('select.option', 'alias', JText::_('ACESEF_COMMON_ALIAS_FIELD'));
		
		// Extensions' title-alias field
		$lists['title_alias'] = JHTML::_('select.genericlist', $url_part, 'title_alias', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->title_alias);
		
		// Menu URL part
		$lists['menu_url_part'] = JHTML::_('select.genericlist', $url_part, 'menu_url_part', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->menu_url_part);
		
		// Base href value
		$base_href = array();
  		$base_href[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_URL_BASEHREF_ORG'));
		$base_href[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_URL_BASEHREF_URL'));
		$base_href[] = JHTML::_('select.option', '3', JText::_('ACESEF_CONFIG_URL_BASEHREF_HOME'));
		$base_href[] = JHTML::_('select.option', '4', JText::_('ACESEF_CONFIG_URL_BASEHREF_DISABLE'));
		$lists['base_href'] = JHTML::_('select.genericlist', $base_href, 'base_href', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->base_href);
		
		// JoomFish
		$lists['multilang'] 	            = AcesefUtility::getRadioList('multilang', $this->AcesefConfig->multilang);
		$lists['joomfish_main_lang_del'] 	= AcesefUtility::getRadioList('joomfish_main_lang_del', $this->AcesefConfig->joomfish_main_lang_del);
		$lists['joomfish_lang_code'] 		= AcesefUtility::getRadioList('joomfish_lang_code', $this->AcesefConfig->joomfish_lang_code);
		$lists['joomfish_trans_url'] 		= AcesefUtility::getRadioList('joomfish_trans_url', $this->AcesefConfig->joomfish_trans_url);
		$lists['joomfish_cookie'] 			= AcesefUtility::getRadioList('joomfish_cookie', $this->AcesefConfig->joomfish_cookie);
		$lists['joomfish_browser'] 			= AcesefUtility::getRadioList('joomfish_browser', $this->AcesefConfig->joomfish_browser);

		$lang_list = array();
		$lang_list[] = JHTML::_('select.option', '0', JText::_('ACESEF_CONFIG_URL_JF_MAINLANG_NONE'));
		$lang_list = array_merge($lang_list, AcesefUtility::getLanguages());
		$lists['joomfish_main_lang'] = JHTML::_('select.genericlist', $lang_list, 'joomfish_main_lang', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->joomfish_main_lang);
		
		// www redirect
		$www = array();
  		$www[] = JHTML::_('select.option', '0', JText::_('ACESEF_CONFIG_URL_WWW_NOACTION'));
		$www[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_URL_WWW_WITH'));
		$www[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_URL_WWW_WHITHOUT'));
		$lists['redirect_to_www'] = JHTML::_('select.genericlist', $www, 'redirect_to_www', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->redirect_to_www);
		
		// Force SSL
		#TODO:find alternative for j30
		//$force_ssl	= JHTML::_('menu.linkoptions', true, true);
		//$lists['force_ssl'] = JHTML::_('select.genericlist', $force_ssl, 'force_ssl[]', 'class="inputbox" size="10" multiple="multiple"', 'value', 'text', $this->AcesefConfig->force_ssl);
		
		
		/*
		//
		// Meta Tags
		//
		*/
		$lists['meta_core'] 			= AcesefUtility::getRadioList('meta_core', $this->AcesefConfig->meta_core);
		$lists['meta_title'] 			= AcesefUtility::getRadioList('meta_title', $this->AcesefConfig->meta_title);
		$lists['meta_title_tag'] 		= AcesefUtility::getRadioList('meta_title_tag', $this->AcesefConfig->meta_title_tag);
		$lists['meta_generator_rem'] 	= AcesefUtility::getRadioList('meta_generator_rem', $this->AcesefConfig->meta_generator_rem);
		
		// Meta Tags list
		$meta = array();
  		$meta[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_META_TDK_ALWAYS'));
		$meta[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_META_TDK_NEVER'));
		$meta[] = JHTML::_('select.option', '3', JText::_('ACESEF_CONFIG_META_TDK_EMPTY'));
		
		// Meta Description
		$lists['meta_desc'] = JHTML::_('select.genericlist', $meta, 'meta_desc', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->meta_desc);
		
		// Meta Keywords
		$lists['meta_key'] = JHTML::_('select.genericlist', $meta, 'meta_key', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->meta_key);
		
		// Use sitename
		$sitename = array();
  		$sitename[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_META_T_USE_SITENAME_1'));
		$sitename[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_META_T_USE_SITENAME_2'));
		$sitename[] = JHTML::_('select.option', '3', JText::_('ACESEF_CONFIG_META_T_USE_SITENAME_3'));
		$lists['meta_t_usesitename'] = JHTML::_('select.genericlist', $sitename, 'meta_t_usesitename', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->meta_t_usesitename);
		
		
		/*
		//
		// Sitemap
		//
		*/
		$lists['sm_ping'] 				= AcesefUtility::getRadioList('sm_ping', $this->AcesefConfig->sm_ping);
		$lists['sm_xml_date'] 			= AcesefUtility::getRadioList('sm_xml_date', $this->AcesefConfig->sm_xml_date);
		$lists['sm_xml_freq'] 			= AcesefUtility::getRadioList('sm_xml_freq', $this->AcesefConfig->sm_xml_freq);
		$lists['sm_xml_prior'] 			= AcesefUtility::getRadioList('sm_xml_prior', $this->AcesefConfig->sm_xml_prior);
		$lists['sm_dot_tree'] 			= AcesefUtility::getRadioList('sm_dot_tree', $this->AcesefConfig->sm_dot_tree);
		$lists['sm_freq'] 				= JHTML::_('select.genericlist', AcesefSitemap::getFrequencyList(), 'sm_freq', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->sm_freq);
		$lists['sm_priority'] 			= JHTML::_('select.genericlist', AcesefSitemap::getPriorityList(), 'sm_priority', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->sm_priority);
		$lists['sm_auto_mode'] 			= AcesefUtility::getRadioList('sm_auto_mode', $this->AcesefConfig->sm_auto_mode);
        $lists['sm_auto_components']	= JHTML::_('select.genericlist', AcesefUtility::getComponents(), 'sm_auto_components[]', 'class="inputbox" size="10" multiple="multiple"', 'value', 'text', $this->AcesefConfig->sm_auto_components);
		$lists['sm_auto_enable_cats'] 	= AcesefUtility::getRadioList('sm_auto_enable_cats', $this->AcesefConfig->sm_auto_enable_cats);
		$lists['sm_auto_cron_mode'] 	= AcesefUtility::getRadioList('sm_auto_cron_mode', $this->AcesefConfig->sm_auto_cron_mode);
		$lists['sm_auto_xml'] 			= AcesefUtility::getRadioList('sm_auto_xml', $this->AcesefConfig->sm_auto_xml);
		$lists['sm_auto_ping_c'] 		= AcesefUtility::getRadioList('sm_auto_ping_c', $this->AcesefConfig->sm_auto_ping_c);
		$lists['sm_auto_ping_s'] 		= AcesefUtility::getRadioList('sm_auto_ping_s', $this->AcesefConfig->sm_auto_ping_s);
		
		// Ping Type
		$ping_type = array();
  		$ping_type[] = JHTML::_('select.option', 'link', JText::_('ACESEF_CONFIG_SITEMAP_XML_URL'));
  		$ping_type[] = JHTML::_('select.option', 'file', JText::_('ACESEF_CONFIG_SITEMAP_FILE'));
		$lists['sm_ping_type'] = JHTML::_('select.genericlist', $ping_type, 'sm_ping_type', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->sm_ping_type);
		
		// Cron Frequency
		$cron_freq = array();
  		$cron_freq[] = JHTML::_('select.option', '1', JText::_('ACESEF_COMMON_SEF') .' '. JText::_('ACESEF_COMMON_URL'));
		$cron_freq[] = JHTML::_('select.option', '4', '4 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_HOURS'));
		$cron_freq[] = JHTML::_('select.option', '8', '8 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_HOURS'));
		$cron_freq[] = JHTML::_('select.option', '12', '12 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_HOURS'));
		$cron_freq[] = JHTML::_('select.option', '24', '1 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_DAYS'));
		$cron_freq[] = JHTML::_('select.option', '48', '2 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_DAYS'));
		$cron_freq[] = JHTML::_('select.option', '168', '1 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_WEEKS'));
		$cron_freq[] = JHTML::_('select.option', '720', '1 ' . JText::_('ACESEF_CONFIG_SITEMAP_AUTO_CRON_FREQ_MONTHS'));
		$lists['sm_auto_cron_freq'] = JHTML::_('select.genericlist', $cron_freq, 'sm_auto_cron_freq', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->sm_auto_cron_freq);
		
		
		/*
		//
		// Tags
		//
		*/
		$lists['tags_mode'] 			= AcesefUtility::getRadioList('tags_mode', $this->AcesefConfig->tags_mode);
		$lists['tags_area'] 			= JHTML::_('select.genericlist', $areas, 'tags_area', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->tags_area);
		$lists['tags_components']		= JHTML::_('select.genericlist', AcesefUtility::getComponents(), 'tags_components[]', 'class="inputbox" size="10" multiple="multiple"', 'value', 'text', $this->AcesefConfig->tags_components);
		$lists['tags_enable_cats'] 		= AcesefUtility::getRadioList('tags_enable_cats', $this->AcesefConfig->tags_enable_cats);
		$lists['tags_in_cats'] 			= AcesefUtility::getRadioList('tags_in_cats', $this->AcesefConfig->tags_in_cats);
		$lists['tags_show_tag_desc'] 	= AcesefUtility::getRadioList('tags_show_tag_desc', $this->AcesefConfig->tags_show_tag_desc);
		$lists['tags_show_prefix'] 		= AcesefUtility::getRadioList('tags_show_prefix', $this->AcesefConfig->tags_show_prefix);
		$lists['tags_show_item_desc'] 	= AcesefUtility::getRadioList('tags_show_item_desc', $this->AcesefConfig->tags_show_item_desc);
		$lists['tags_exp_item_desc'] 	= AcesefUtility::getRadioList('tags_exp_item_desc', $this->AcesefConfig->tags_exp_item_desc);
		$lists['tags_published'] 		= AcesefUtility::getRadioList('tags_published', $this->AcesefConfig->tags_published);
		$lists['tags_auto_mode'] 		= AcesefUtility::getRadioList('tags_auto_mode', $this->AcesefConfig->tags_auto_mode);
        $lists['tags_auto_components']	= JHTML::_('select.genericlist', AcesefUtility::getComponents(), 'tags_auto_components[]', 'class="inputbox" size="10" multiple="multiple"', 'value', 'text', $this->AcesefConfig->tags_auto_components);
		
		// Order
		$order = array();
  		$order[] = JHTML::_('select.option', 'ordering', JText::_('ACESEF_CONFIG_TAGS_ORDER_1'));
  		$order[] = JHTML::_('select.option', 'ordering DESC', JText::_('ACESEF_CONFIG_TAGS_ORDER_2'));
  		$order[] = JHTML::_('select.option', 'title', JText::_('ACESEF_CONFIG_TAGS_ORDER_3'));
  		$order[] = JHTML::_('select.option', 'title DESC', JText::_('ACESEF_CONFIG_TAGS_ORDER_4'));
  		$order[] = JHTML::_('select.option', 'hits', JText::_('ACESEF_CONFIG_TAGS_ORDER_5'));
  		$order[] = JHTML::_('select.option', 'hits DESC', JText::_('ACESEF_CONFIG_TAGS_ORDER_6'));
		$lists['tags_order'] = JHTML::_('select.genericlist', $order, 'tags_order', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->tags_order);
		
		// Position
		$pos = array();
  		$pos[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_POSITION_1'));
		$pos[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_POSITION_2'));
		$lists['tags_position'] = JHTML::_('select.genericlist', $pos, 'tags_position', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->tags_position);
		
		/*
		//
		// Internal Links
		//
		*/
		$lists['ilinks_mode'] 			= AcesefUtility::getRadioList('ilinks_mode', $this->AcesefConfig->ilinks_mode);
        $lists['ilinks_area'] 			= JHTML::_('select.genericlist', $areas, 'ilinks_area', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->ilinks_area);
		$lists['ilinks_components'] 	= JHTML::_('select.genericlist', AcesefUtility::getComponents(), 'ilinks_components[]', 'class="inputbox" size="10" multiple="multiple"', 'value', 'text', $this->AcesefConfig->ilinks_components);
		$lists['ilinks_enable_cats'] 	= AcesefUtility::getRadioList('ilinks_enable_cats', $this->AcesefConfig->ilinks_enable_cats);
		$lists['ilinks_in_cats'] 		= AcesefUtility::getRadioList('ilinks_in_cats', $this->AcesefConfig->ilinks_in_cats);
		$lists['ilinks_case'] 			= AcesefUtility::getRadioList('ilinks_case', $this->AcesefConfig->ilinks_case);
		$lists['ilinks_published'] 		= AcesefUtility::getRadioList('ilinks_published', $this->AcesefConfig->ilinks_published);
		$lists['ilinks_nofollow'] 		= AcesefUtility::getRadioList('ilinks_nofollow', $this->AcesefConfig->ilinks_nofollow);
		$lists['ilinks_blank'] 			= AcesefUtility::getRadioList('ilinks_blank', $this->AcesefConfig->ilinks_blank);

		
		/*
		//
		// Social Bookmarks
		//
		*/
		$lists['bookmarks_mode'] 		= AcesefUtility::getRadioList('bookmarks_mode', $this->AcesefConfig->bookmarks_mode);
       	$lists['bookmarks_area'] 		= JHTML::_('select.genericlist', $areas, 'bookmarks_area', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->bookmarks_area);
		 $lists['bookmarks_components'] = JHTML::_('select.genericlist', AcesefUtility::getComponents(), 'bookmarks_components[]', 'class="inputbox" size="10" multiple="multiple"', 'value', 'text', $this->AcesefConfig->bookmarks_components);
		$lists['bookmarks_enable_cats'] = AcesefUtility::getRadioList('bookmarks_enable_cats', $this->AcesefConfig->bookmarks_enable_cats);
		$lists['bookmarks_in_cats'] 	= AcesefUtility::getRadioList('bookmarks_in_cats', $this->AcesefConfig->bookmarks_in_cats);
		$lists['bookmarks_published'] 	= AcesefUtility::getRadioList('bookmarks_published', $this->AcesefConfig->bookmarks_published);
		
		// Icons
		$icons = array();
  		$icons[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_POSITION_1'));
		$icons[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_POSITION_2'));
		$icons[] = JHTML::_('select.option', '3', JText::_('ACESEF_CONFIG_POSITION_3'));
		$lists['bookmarks_icons_pos'] = JHTML::_('select.genericlist', $icons, 'bookmarks_icons_pos', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->bookmarks_icons_pos);
		
		// Type Filter
		$type_list[] = JHTML::_('select.option', 'icon', JText::_('ACESEF_BOOKMARKS_TYPE_1'));
		$type_list[] = JHTML::_('select.option', 'iconset', JText::_('ACESEF_BOOKMARKS_TYPE_2'));
		$type_list[] = JHTML::_('select.option', 'badge', JText::_('ACESEF_BOOKMARKS_TYPE_3'));
		$lists['bookmarks_type'] = JHTML::_('select.genericlist', $type_list, 'bookmarks_type', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->bookmarks_type);
		
		
		/*
		//
		// User Interface
		//
		*/
		$lists['ui_sef_language'] 		= AcesefUtility::getRadioList('ui_sef_language', $this->AcesefConfig->ui_sef_language);
		$lists['ui_sef_published'] 		= AcesefUtility::getRadioList('ui_sef_published', $this->AcesefConfig->ui_sef_published);
		$lists['ui_sef_used'] 			= AcesefUtility::getRadioList('ui_sef_used', $this->AcesefConfig->ui_sef_used);
		$lists['ui_sef_locked'] 		= AcesefUtility::getRadioList('ui_sef_locked', $this->AcesefConfig->ui_sef_locked);
		$lists['ui_sef_blocked'] 		= AcesefUtility::getRadioList('ui_sef_blocked', $this->AcesefConfig->ui_sef_blocked);
		$lists['ui_sef_cached'] 		= AcesefUtility::getRadioList('ui_sef_cached', $this->AcesefConfig->ui_sef_cached);
		$lists['ui_sef_date'] 			= AcesefUtility::getRadioList('ui_sef_date', $this->AcesefConfig->ui_sef_date);
		$lists['ui_sef_hits'] 			= AcesefUtility::getRadioList('ui_sef_hits', $this->AcesefConfig->ui_sef_hits);
		$lists['ui_sef_id'] 			= AcesefUtility::getRadioList('ui_sef_id', $this->AcesefConfig->ui_sef_id);
		$lists['ui_moved_published'] 	= AcesefUtility::getRadioList('ui_moved_published', $this->AcesefConfig->ui_moved_published);
		$lists['ui_moved_hits'] 		= AcesefUtility::getRadioList('ui_moved_hits', $this->AcesefConfig->ui_moved_hits);
		$lists['ui_moved_clicked'] 		= AcesefUtility::getRadioList('ui_moved_clicked', $this->AcesefConfig->ui_moved_clicked);
		$lists['ui_moved_cached'] 		= AcesefUtility::getRadioList('ui_moved_cached', $this->AcesefConfig->ui_moved_cached);
		$lists['ui_moved_id'] 			= AcesefUtility::getRadioList('ui_moved_id', $this->AcesefConfig->ui_moved_id);
		$lists['ui_metadata_keys'] 		= AcesefUtility::getRadioList('ui_metadata_keys', $this->AcesefConfig->ui_metadata_keys);
		$lists['ui_metadata_published'] = AcesefUtility::getRadioList('ui_metadata_published', $this->AcesefConfig->ui_metadata_published);
		$lists['ui_metadata_cached'] 	= AcesefUtility::getRadioList('ui_metadata_cached', $this->AcesefConfig->ui_metadata_cached);
		$lists['ui_metadata_id'] 		= AcesefUtility::getRadioList('ui_metadata_id', $this->AcesefConfig->ui_metadata_id);
		$lists['ui_sitemap_title'] 		= AcesefUtility::getRadioList('ui_sitemap_title', $this->AcesefConfig->ui_sitemap_title);
		$lists['ui_sitemap_published'] 	= AcesefUtility::getRadioList('ui_sitemap_published', $this->AcesefConfig->ui_sitemap_published);
		$lists['ui_sitemap_id'] 		= AcesefUtility::getRadioList('ui_sitemap_id', $this->AcesefConfig->ui_sitemap_id);
		$lists['ui_sitemap_parent'] 	= AcesefUtility::getRadioList('ui_sitemap_parent', $this->AcesefConfig->ui_sitemap_parent);
		$lists['ui_sitemap_order'] 		= AcesefUtility::getRadioList('ui_sitemap_order', $this->AcesefConfig->ui_sitemap_order);
		$lists['ui_sitemap_date'] 		= AcesefUtility::getRadioList('ui_sitemap_date', $this->AcesefConfig->ui_sitemap_date);
		$lists['ui_sitemap_frequency'] 	= AcesefUtility::getRadioList('ui_sitemap_frequency', $this->AcesefConfig->ui_sitemap_frequency);
		$lists['ui_sitemap_priority'] 	= AcesefUtility::getRadioList('ui_sitemap_priority', $this->AcesefConfig->ui_sitemap_priority);
		$lists['ui_sitemap_cached'] 	= AcesefUtility::getRadioList('ui_sitemap_cached', $this->AcesefConfig->ui_sitemap_cached);
		$lists['ui_tags_published'] 	= AcesefUtility::getRadioList('ui_tags_published', $this->AcesefConfig->ui_tags_published);
		$lists['ui_tags_ordering'] 		= AcesefUtility::getRadioList('ui_tags_ordering', $this->AcesefConfig->ui_tags_ordering);
		$lists['ui_tags_cached'] 		= AcesefUtility::getRadioList('ui_tags_cached', $this->AcesefConfig->ui_tags_cached);
		$lists['ui_tags_hits'] 			= AcesefUtility::getRadioList('ui_tags_hits', $this->AcesefConfig->ui_tags_hits);
		$lists['ui_tags_id'] 			= AcesefUtility::getRadioList('ui_tags_id', $this->AcesefConfig->ui_tags_id);
		$lists['ui_ilinks_published'] 	= AcesefUtility::getRadioList('ui_ilinks_published', $this->AcesefConfig->ui_ilinks_published);
		$lists['ui_ilinks_nofollow'] 	= AcesefUtility::getRadioList('ui_ilinks_nofollow', $this->AcesefConfig->ui_ilinks_nofollow);
		$lists['ui_ilinks_blank'] 		= AcesefUtility::getRadioList('ui_ilinks_blank', $this->AcesefConfig->ui_ilinks_blank);
		$lists['ui_ilinks_limit'] 		= AcesefUtility::getRadioList('ui_ilinks_limit', $this->AcesefConfig->ui_ilinks_limit);
		$lists['ui_ilinks_cached'] 		= AcesefUtility::getRadioList('ui_ilinks_cached', $this->AcesefConfig->ui_ilinks_cached);
		$lists['ui_ilinks_id'] 			= AcesefUtility::getRadioList('ui_ilinks_id', $this->AcesefConfig->ui_ilinks_id);
		$lists['ui_bookmarks_published'] = AcesefUtility::getRadioList('ui_bookmarks_published', $this->AcesefConfig->ui_bookmarks_published);
		$lists['ui_bookmarks_id'] 		= AcesefUtility::getRadioList('ui_bookmarks_id', $this->AcesefConfig->ui_bookmarks_id);
		
		// Control Panel Layout
		$ui_cpanel = array();
  		$ui_cpanel[] = JHTML::_('select.option', '1', JText::_('ACESEF_CONFIG_UI_CP_1'));
		$ui_cpanel[] = JHTML::_('select.option', '2', JText::_('ACESEF_CONFIG_UI_CP_2'));
		$lists['ui_cpanel'] = JHTML::_('select.genericlist', $ui_cpanel, 'ui_cpanel', 'class="inputbox" size="1"' ,'value', 'text', $this->AcesefConfig->ui_cpanel);
		
		return $lists;
	}
}
?>